function League() {

};



var Round = function(number, date) {

    this.number = number;

    this.date = date;

    this.id = new Array(0);

    this.elapsedTime=null;

  }



Round.prototype.ElapsedTime = function(now) {

	var f = now - this.date;

	if (f > 0) {

	  this.diff="finish.";

	  return;

	}

	f = -f;

	var s = Math.floor(f/1000);

	var m = Math.floor(s/60);

	var h = Math.floor(m/60);

	var d = Math.floor(h/24);

	var str;

	if (d > 0) {

	  str = d + " day" + (d == 1 ? "" : "s") + " to kick off.";

	} else if (h > 2) {

	  str = h + " hours to kick off.";

	} else {

	  str = h > 0 

          ? h + " hour" + (h > 1 ? "s and " : " and ")

          : "";

    str += m%60 + " minute" + (m > 1 ? "s" : "") + " to kick off.";

	}

  this.diff = str;

};



/* ----------------------------------------------

 * Get League data

 * ---------------------------------------------- */

League.HTTPGet = function () {

  var URL = HTTP.hattrickServer

                      + "/Common/chppxml.axd?file=leaguedetails";

  EventSystem.HTTPRequest(URL, League.ParseGet, "request.league_data");

    

};



League.ParseGet = function(xml) {

  League.countryId =

    parseInt(Util.Parse("<LeagueID>(.*?)</LeagueID>", xml), 10);



  League.countryName =

    Util.Parse("<LeagueName>(.*?)</LeagueName>", xml);



  League.level = 

    parseInt(Util.Parse("<LeagueLevel>(.*?)</LeagueLevel>", xml), 10);



  League.maxLevel = 

    parseInt(Util.Parse("<MaxLevel>(.*?)</MaxLevel>", xml), 10);



  League.levelUnitId =

    parseInt(Util.Parse("<LeagueLevelUnitID>(.*?)</LeagueLevelUnitID>", xml), 10);

  League.levelUnitName =

    Util.Parse("<LeagueLevelUnitName>(.*?)</LeagueLevelUnitName>", xml);



  League.teams = League.ParseTeams(xml);

  EventSystem.Declare(EventSystem.ev.MY_LEAGUE);

};



League.ParseTeams = function(xml) {

  //var regStr = "(<Team\\s(?:.*?)</Team>)";

  var regStr = "(<Team>(.*?)</Team>)";

  var regExp, found;

  var teamXml, teams=null;

  try {

    regExp = new RegExp(regStr, "g");

    teams = new Array(0);

    for(;found = regExp.exec(xml);) {

    	teamXml = found[1];

      // Gonzo remove: teams[teams.length] = Util.Parse("<TeamID>(.*?)</TeamID>", teamXml);

      // Gonzo

      var i=Util.Parse("<TeamID>(.*?)</TeamID>", teamXml);

      teams[i] = new Array();

      teams[i].name = Util.Parse("<TeamName>(.*?)</TeamName>", teamXml);

      teams[i].id = i;

      teams[i].position = parseInt(Util.Parse("<Position>(.*?)</Position>", teamXml), 10);

      teams[i].livePosition = teams[i].position;

      teams[i].matches = parseInt(Util.Parse("<Matches>(.*?)</Matches>", teamXml), 10);

      teams[i].liveMatches = teams[i].matches;

      teams[i].goalsFor = parseInt(Util.Parse("<GoalsFor>(.*?)</GoalsFor>", teamXml), 10);

      teams[i].liveGoalsFor = teams[i].goalsFor;

      teams[i].goalsAgainst = parseInt(Util.Parse("<GoalsAgainst>(.*?)</GoalsAgainst>", teamXml), 10);

      teams[i].liveGoalsAgainst = teams[i].goalsAgainst;

      teams[i].points = parseInt(Util.Parse("<Points>(.*?)</Points>", teamXml), 10);

      teams[i].livePoints = teams[i].points;

      // End

    }

  } catch(e) {

    alert("League.ParseGet: " + e);

  }

  return teams;



};



/* ----------------------------------------------

 * Get League games

 * ---------------------------------------------- */



League.HTTPFixtures = function () {

    var URL = HTTP.hattrickServer

                      + "/Common/chppxml.axd?file=leaguefixtures";

                      

  EventSystem.HTTPRequest(URL, League.ParseFixtures, "request.league_games");

};



League.ParseFixtures = function(xml) {

  var fetchDate = Time.parseFetchDate(xml);

  //var regStr = "(<Match\\s(?:.*?)</Match>)";

  var regStr = "(<Match>(.*?)</Match>)";

  var regExp, found;

  try {

    regExp = new RegExp(regStr, "g");

    var rounds = new Array();

    var id, round, date, home, away;

    var firstRound=Number.MAX_VALUE, lastRound=Number.MIN_VALUE;



    // get all league games from hattrick

    for(;found = regExp.exec(xml);) {

      id = League.ParseMatchId(found[1]);

      round = League.ParseMatchRound(found[1]);

      date = League.ParseMatchDate(found[1]);

      home = Live.ParseHomeTeam(found[1]);

      away = Live.ParseAwayTeam(found[1]);



      // just check if firstRound is 1 and lastRound is 14 

      if (round>lastRound) lastRound=round;

      if (round<firstRound) firstRound=round;



      if (!rounds[round]) {

        rounds[round] = new Round(round, date);

      }

      rounds[round].id[rounds[round].id.length] = id;

    }



    var i, length;

    var currentRound=1;

    var nearestDate=Number.MAX_VALUE;

    var diffDate;



    length = rounds.length;



    // check what is the nearest game 

    for (i=1; i<length; i++) {

      diffDate = Math.abs(rounds[i].date - fetchDate);

      if (diffDate < nearestDate) {

        nearestDate = diffDate;

        currentRound = i;

      }

    }

  } catch(e) {

    alert("League.ParseFixtures (get info): " + e);

  }

  try {

    var g, h, matchId;



    League.rounds = rounds;

    League.currentRound = rounds[currentRound];

    var p = LiveFox.prefs.matches.league;

    if (

      p.get

      && (

        !p.within

        || Math.abs(League.currentRound.date-Time.hattrickTime) < p.withinHours*Time.HOUR 

      )

    ) {

      LiveFox.showLeague= true;

    } else {

      LiveFox.showLeague= false;

    }

    

    if (LiveFox.showLeague) {

    	// Gonzo

      document.getElementById("winbox_leaguetable").hidden = false;

      UpdateElementBoxLeagueTable(League);

      // End

      UpdateElementBoxLeague(League);

      for (i=0; i<rounds[currentRound].id.length; i++) {

        matchId = rounds[currentRound].id[i];

        LiveFox.AddLiveMatch(matchId, "False");

      }

    }

  } catch(e) {

    alert("League.ParseFixtures (set info): " + e);

  }

  EventSystem.Declare(EventSystem.ev.MY_LEAGUE_MATCHES);

};



// Gonzo

League.sortTable = function(){

  var tmp = Array();

  for(var id in League.teams){

    tmp[League.teams[id].livePosition] = League.teams[id];

  }

  var change = true;

  while(change){

    change = false;

    for(var i=1; i<8; i++){

      if(League.compareTeams(tmp[i], tmp[i+1]) < 0){

        var tmpTeam = tmp[i];

        tmp[i] = tmp[i+1];

        tmp[i+1] = tmpTeam;

        change = true;

      }

    }

  }

  for(var j=1; j<=8; j++){

    League.teams[tmp[j].id].livePosition = j;

  }

};



League.compareTeams = function(team1, team2){

  if(team1.livePoints > team2.livePoints) return 1;

  else{

    if(team1.livePoints < team2.livePoints) return -1;

    else{

      if(team1.liveGoalsFor - team1.liveGoalsAgainst > team2.liveGoalsFor - team2.liveGoalsAgainst)

        return 1;

      else{

        if(team1.liveGoalsFor - team1.liveGoalsAgainst < team2.liveGoalsFor - team2.liveGoalsAgainst)

          return -1;

        else{

          if(team1.liveGoalsFor > team2.liveGoalsFor) return 1;

          else{

            if(team1.liveGoalsFor < team2.liveGoalsFor) return -1;

            else return 0;

          }

        }

      }

    }

  }

};

// End



/* ----------------------------------------------------------------

 * commun Parse functions

 * ---------------------------------------------------------------- */



League.ParseMatchId = function(xml) {

	return Util.Parse("<MatchID>(.*?)</MatchID>", xml);

};



League.ParseMatchRound = function(xml) {

  return parseInt(Util.Parse("<MatchRound>(.*?)</MatchRound>", xml), 10);

};



League.ParseMatchDate = function(xml) {

  return Time.parseDate(Util.Parse("<MatchDate>(.*?)</MatchDate>", xml));

};



League.parseHomeTeam = function(xml) {

  return Time.parseDate(Util.Parse("<MatchDate>(.*?)</MatchDate>", xml));

};

League.parseAwayTeam = function(xml) {

  return Time.parseDate(Util.Parse("<MatchDate>(.*?)</MatchDate>", xml));

};









